Index: TWiki/Func.pm
===================================================================
--- TWiki/Func.pm	(revision 13172)
+++ TWiki/Func.pm	(working copy)
@@ -277,7 +277,7 @@
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
     ASSERT(defined $url) if DEBUG;
 
-    return $TWiki::Plugins::SESSION->{net}->getExternalResource( $url );
+    return $TWiki::NET->getExternalResource( $url );
 }
 
 =pod
@@ -311,7 +311,7 @@
 
 sub getSessionKeys {
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    my $hash = $TWiki::Plugins::SESSION->{loginManager}->getSessionValues();
+    my $hash = $TWiki::LOGIN->getSessionValues();
     return keys %{$hash};
 }
 
@@ -331,7 +331,7 @@
 #   my( $key ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
 
-    return $TWiki::Plugins::SESSION->{loginManager}->getSessionValue( @_ );
+    return $TWiki::LOGIN->getSessionValue( @_ );
 }
 
 
@@ -352,7 +352,7 @@
 #   my( $key, $value ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
 
-    $TWiki::Plugins::SESSION->{loginManager}->setSessionValue( @_ );
+    $TWiki::LOGIN->setSessionValue( @_ );
 }
 
 =pod
@@ -371,7 +371,7 @@
 sub clearSessionValue {
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
 
-    return $TWiki::Plugins::SESSION->{loginManager}->clearSessionValue( @_ );
+    return $TWiki::LOGIN->clearSessionValue( @_ );
 }
 
 =pod
@@ -457,15 +457,15 @@
     my $old = {
         web => $twiki->{webName},
         topic => $twiki->{topicName},
-        mark => $twiki->{prefs}->mark() };
+        mark => $TWiki::PREFS->mark() };
 
     push( @{$twiki->{_FUNC_PREFS_STACK}}, $old );
     $twiki->{webName} = $web;
     $twiki->{topicName} = $topic;
-    $twiki->{prefs}->pushWebPreferences( $web );
-    $twiki->{prefs}->pushPreferences( $web, $topic, 'TOPIC' );
-    $twiki->{prefs}->pushPreferenceValues(
-        'SESSION', $twiki->{loginManager}->getSessionValues() );
+    $TWiki::PREFS->pushWebPreferences( $web );
+    $TWiki::PREFS->pushPreferences( $web, $topic, 'TOPIC' );
+    $TWiki::PREFS->pushPreferenceValues(
+        'SESSION', $TWiki::LOGIN->getSessionValues() );
 }
 
 =pod
@@ -484,7 +484,7 @@
     my $twiki = $TWiki::Plugins::SESSION;
     ASSERT(scalar(@{$twiki->{_FUNC_PREFS_STACK}})) if DEBUG;
     my $old = pop( @{$twiki->{_FUNC_PREFS_STACK}} );
-    $twiki->{prefs}->restore( $old->{mark});
+    $TWiki::PREFS->restore( $old->{mark});
     $twiki->{webName} = $old->{web};
     $twiki->{topicName} = $old->{topic};
 }
@@ -522,12 +522,11 @@
 
 sub getPreferencesValue {
     my( $key, $web ) = @_;
-    ASSERT($TWiki::Plugins::SESSION) if DEBUG;
     if( $web ) {
-        return $TWiki::Plugins::SESSION->{prefs}->getWebPreferencesValue(
+        return $TWiki::PREFS->getWebPreferencesValue(
             $key, $web );
     } else {
-        return $TWiki::Plugins::SESSION->{prefs}->getPreferencesValue( $key );
+        return $TWiki::PREFS->getPreferencesValue( $key );
     }
 }
 
@@ -553,7 +552,7 @@
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
     my $package = caller;
     $package =~ s/.*:://; # strip off TWiki::Plugins:: prefix
-    return $TWiki::Plugins::SESSION->{prefs}->getPreferencesValue( "\U$package\E_$key" );
+    return $TWiki::PREFS->getPreferencesValue( "\U$package\E_$key" );
 }
 
 =pod
@@ -723,7 +722,7 @@
     my( $wiki ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
     return '' unless $wiki;
-    my $user = $TWiki::Plugins::SESSION->{users}->findUser( $wiki, undef, 1 );
+    my $user = $TWiki::USERS->findUser( $wiki, undef, 1 );
     return $wiki unless $user;
     return $user->login();
 }
@@ -745,7 +744,7 @@
     my( $login, $dontAddWeb ) = @_;
     return '' unless $login;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    my $user = $TWiki::Plugins::SESSION->{users}->findUser( $login, undef, 1 );
+    my $user = $TWiki::USERS->findUser( $login, undef, 1 );
     return '' unless $user;
     return $user->wikiName() if $dontAddWeb;
     return $user->webDotWikiName();
@@ -769,7 +768,7 @@
     ASSERT($email) if DEBUG;
 
     my %matches;
-    my $ua = $TWiki::Plugins::SESSION->{users}->findUserByEmail( $email );
+    my $ua = $TWiki::USERS->findUserByEmail( $email );
     if ($ua) {
         foreach my $user (@$ua) {
             if( $dontAddWeb ) {
@@ -798,7 +797,7 @@
     my( $user ) = @_;
 
     if( $user ) {
-        $user = $TWiki::Plugins::SESSION->{users}->findUser($user, undef, 1);
+        $user = $TWiki::USERS->findUser($user, undef, 1);
     } else {
         $user = $TWiki::Plugins::SESSION->{user};
     }
@@ -836,7 +835,7 @@
     my ($user) = @_;
 
     if ($user) {
-        $user = $TWiki::Plugins::SESSION->{users}->findUser($user, undef, 1);
+        $user = $TWiki::USERS->findUser($user, undef, 1);
     } else {
         $user = $TWiki::Plugins::SESSION->{user};
     }
@@ -863,11 +862,11 @@
     my ($group, $user) = @_;
 
     if ($user) {
-        $user = $TWiki::Plugins::SESSION->{users}->findUser($user, $user, 1);
+        $user = $TWiki::USERS->findUser($user, $user, 1);
     } else {
         $user = $TWiki::Plugins::SESSION->{user};
     }
-    $group = $TWiki::Plugins::SESSION->{users}->findUser($group, $group, 1);
+    $group = $TWiki::USERS->findUser($group, $group, 1);
     return () unless $group->isGroup();
     return $user->isInGroup( $group );
 }
@@ -895,8 +894,7 @@
 =cut
 
 sub eachUser {
-    my $session = $TWiki::Plugins::SESSION;
-    my $it = $session->{users}->eachUser();
+    my $it = $TWiki::USERS->eachUser();
     # Get the name from the user object
     $it->{process} = sub { return $_[0]->wikiName() };
     return $it;
@@ -916,7 +914,7 @@
     my ($user) = @_;
 
     if ($user) {
-        $user = $TWiki::Plugins::SESSION->{users}->findUser($user, $user, 1);
+        $user = $TWiki::USERS->findUser($user, $user, 1);
     } else {
         $user = $TWiki::Plugins::SESSION->{user};
     }
@@ -948,8 +946,7 @@
 =cut
 
 sub eachGroup {
-    my $session = $TWiki::Plugins::SESSION;
-    my $it = $session->{users}->eachGroup();
+    my $it = $TWiki::USERS->eachGroup();
     # Get the name from the user object
     $it->{process} = sub { return $_[0]->wikiName() };
     return $it;
@@ -966,9 +963,8 @@
 sub isGroup {
     my( $group ) = @_;
 
-    my $users = $TWiki::Plugins::SESSION->{users};
-    my $uo = $users->findUser( $group );
-    return $users->isGroup( $uo );
+    my $uo = $TWiki::USERS->findUser( $group );
+    return $TWiki::USERS->isGroup( $uo );
 }
 
 =pod
@@ -994,8 +990,7 @@
 
 sub eachGroupMember {
     my $group = shift;
-    my $session = $TWiki::Plugins::SESSION;
-    my $user = $session->{users}->findUser($group);
+    my $user = $TWiki::USERS->findUser($group);
     return undef unless $user->isGroup();
     my $it = $user->eachGroupMember();
     # Get the name from the user object
@@ -1085,8 +1080,8 @@
     return 1 unless ( $user );
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
     $text = undef unless $text;
-    $user = $TWiki::Plugins::SESSION->{users}->findUser( $user );
-    return $TWiki::Plugins::SESSION->{security}->checkAccessPermission(
+    $user = $TWiki::USERS->findUser( $user );
+    return $TWiki::ACCESS->checkAccessPermission(
         $type, $user, $text, $meta, $topic, $web );
 }
 
@@ -1122,7 +1117,7 @@
 sub getListOfWebs {
     my $filter = shift;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{store}->getListOfWebs($filter);
+    return $TWiki::STORE->getListOfWebs($filter);
 }
 
 =pod
@@ -1139,7 +1134,7 @@
 sub webExists {
 #   my( $web ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{store}->webExists( @_ );
+    return $TWiki::STORE->{store}->webExists( @_ );
 }
 
 =pod
@@ -1174,7 +1169,7 @@
 
 sub createWeb {
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    $TWiki::Plugins::SESSION->{store}->createWeb(
+    $TWiki::STORE->createWeb(
         $TWiki::Plugins::SESSION->{user}, @_ );
 }
 
@@ -1212,7 +1207,7 @@
 
 sub moveWeb {
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{store}->moveWeb(
+    return $TWiki::STORE->moveWeb(
         @_, $TWiki::Plugins::SESSION->{user});
 
 }
@@ -1232,7 +1227,7 @@
 sub getTopicList {
 #   my( $web ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{store}->getTopicNames ( @_ );
+    return $TWiki::STORE->getTopicNames ( @_ );
 }
 
 =pod
@@ -1251,7 +1246,7 @@
 sub topicExists {
     my( $web, $topic ) = $TWiki::Plugins::SESSION->normalizeWebTopicName( @_ );
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{store}->topicExists( $web, $topic );
+    return $TWiki::STORE->topicExists( $web, $topic );
 }
 
 =pod
@@ -1275,21 +1270,20 @@
     ( $web, $topic ) = normalizeWebTopicName( $web, $topic );
     $script ||= 'edit';
 
-    my $lease = $TWiki::Plugins::SESSION->{store}->getLease( $web, $topic );
+    my $lease = $TWiki::STORE->getLease( $web, $topic );
     if( $lease ) {
         my $remain = $lease->{expires} - time();
-        my $session = $TWiki::Plugins::SESSION;
 
         if( $remain > 0 ) {
             my $who = $lease->{user}->login();
             my $wn = $lease->{user}->webDotWikiName();
             my $past = TWiki::Time::formatDelta(time()-$lease->{taken},
-                                                $TWiki::Plugins::SESSION->{i18n}
+                                                $TWiki::I18N
                                                );
             my $future = TWiki::Time::formatDelta($lease->{expires}-time(),
-                                                  $TWiki::Plugins::SESSION->{i18n}
+                                                  $TWiki::I18N
                                                  );
-            return( $session->getOopsUrl( 'leaseconflict',
+            return( $TWiki::SESSION->getOopsUrl( 'leaseconflict',
                                           def => 'lease_active',
 					  keep => 1,   # Need to keep parameters across redirect
                                           web => $web,
@@ -1323,14 +1317,12 @@
 
 sub setTopicEditLock {
     my( $web, $topic, $lock ) = @_;
-    ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    my $session = $TWiki::Plugins::SESSION;
-    my $store = $session->{store};
+
     if( $lock ) {
-        $store->setLease( $web, $topic, $session->{user},
+        $TWiki::STORE->setLease( $web, $topic, $TWiki::SESSION->{user},
                           $TWiki::cfg{LeaseLength} );
     } else {
-        $store->clearLease( $web, $topic );
+        $TWiki::STORE->clearLease( $web, $topic );
     }
     return '';
 }
@@ -1369,7 +1361,7 @@
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
     ASSERT($meta) if DEBUG;
 
-    return $TWiki::Plugins::SESSION->{store}->saveTopic
+    return $TWiki::STORE->saveTopic
       ( $TWiki::Plugins::SESSION->{user}, $web, $topic, $text, $meta,
         $options );
 
@@ -1412,46 +1404,40 @@
     my( $web, $topic, $text, $ignorePermissions, $dontNotify ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
 
-    my $session = $TWiki::Plugins::SESSION;
-    my( $mirrorSite, $mirrorViewURL ) = $session->readOnlyMirrorWeb( $web );
-    return $session->getOopsUrl
-      ( 'mirror', web => $web, topic => $topic,
-        params => [ $mirrorSite, $mirrorViewURL ] ) if( $mirrorSite );
-
     # check access permission
     unless( $ignorePermissions ||
-            $session->{security}->checkAccessPermission(
-                'CHANGE', $session->{user}, undef, undef,
+            $TWiki::ACCESS->checkAccessPermission(
+                'CHANGE', $TWiki::SESSION->{user}, undef, undef,
                 $topic, $web )
           ) {
         my @plugin = caller();
-        return $session->getOopsUrl( 'accessdenied',
+        return $TWiki::SESSION->getOopsUrl( 'accessdenied',
                                      def => 'topic_access',
                                      web => $web,
                                      topic => $topic,
                                      params => [ 'in', $plugin[0] ] );
     }
 
-    return $session->getOopsUrl( 'attention',
+    return $TWiki::SESSION->getOopsUrl( 'attention',
                                  def => 'save_error',
                                  web => $web,
                                  topic => $topic )
       unless( defined $text );
 
     # extract meta data and merge old attachment meta data
-    my $meta = new TWiki::Meta( $session, $web, $topic );
-    $session->{store}->extractMetaData( $meta, \$text );
+    my $meta = new TWiki::Meta( $web, $topic );
+    $TWiki::STORE->extractMetaData( $meta, \$text );
     $meta->remove( 'FILEATTACHMENT' );
 
     my( $oldMeta, $oldText ) =
-      $session->{store}->readTopic( undef, $web, $topic, undef );
+      $TWiki::STORE->readTopic( undef, $web, $topic, undef );
     $meta->copyFrom( $oldMeta, 'FILEATTACHMENT' );
     # save topic
     my $error =
-      $session->{store}->saveTopic
-        ( $session->{user}, $web, $topic, $text, $meta,
+      $TWiki::STORE->saveTopic
+        ( $TWiki::SESSION->{user}, $web, $topic, $text, $meta,
           { notify => $dontNotify } );
-    return $session->getOopsUrl
+    return $TWiki::SESSION->getOopsUrl
       ( 'attention', def => 'save_error',
         web => $web, topic => $topic, params => $error ) if( $error );
     return '';
@@ -1500,7 +1486,7 @@
 
     return if( $newWeb eq $web && $newTopic eq $topic );
 
-    $TWiki::Plugins::SESSION->{store}->moveTopic(
+    $TWiki::STORE->moveTopic(
         $web, $topic,
         $newWeb, $newTopic,
         $TWiki::Plugins::SESSION->{user} );
@@ -1538,7 +1524,7 @@
 sub getRevisionInfo {
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
     my( $date, $user, $rev, $comment ) =
-      $TWiki::Plugins::SESSION->{store}->getRevisionInfo( @_ );
+      $TWiki::STORE->getRevisionInfo( @_ );
     $user = $user->wikiName();
     return ( $date, $user, $rev, $comment );
 }
@@ -1560,7 +1546,7 @@
 
 sub getRevisionAtTime {
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{store}->getRevisionAtTime( @_ );
+    return $TWiki::STORE->getRevisionAtTime( @_ );
 }
 
 =pod
@@ -1587,7 +1573,7 @@
     #my( $web, $topic, $rev ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
 
-    return $TWiki::Plugins::SESSION->{store}->readTopic( undef, @_ );
+    return $TWiki::STORE->readTopic( undef, @_ );
 }
 
 =pod
@@ -1617,9 +1603,7 @@
 
     my $text;
     try {
-        $text =
-          $TWiki::Plugins::SESSION->{store}->readTopicRaw
-            ( $user, $web, $topic, $rev );
+        $text = $TWiki::STORE->readTopicRaw( $user, $web, $topic, $rev );
     } catch TWiki::AccessControlException with {
         my $e = shift;
         $text = $TWiki::Plugins::SESSION->getOopsUrl
@@ -1650,8 +1634,7 @@
 
     ( $web, $topic ) =
       $TWiki::Plugins::SESSION->normalizeWebTopicName( $web, $topic );
-    return $TWiki::Plugins::SESSION->{store}->attachmentExists(
-        $web, $topic, $attachment );
+    return $TWiki::STORE->attachmentExists( $web, $topic, $attachment );
 }
 
 =pod
@@ -1694,7 +1677,7 @@
     my $result;
 
 #    try {
-        $result = $TWiki::Plugins::SESSION->{store}->readAttachment(
+        $result = $TWiki::STORE->readAttachment(
             $TWiki::Plugins::SESSION->{user}, @_ );
 #    } catch Error::Simple with {
 #    };
@@ -1744,7 +1727,7 @@
     my $result = undef;
 
     try {
-        $TWiki::Plugins::SESSION->{store}->saveAttachment(
+        $TWiki::STORE->saveAttachment(
             $web, $topic, $name,
             $TWiki::Plugins::SESSION->{user},
             $data );
@@ -1806,7 +1789,7 @@
                  $newTopic eq $topic &&
                    $newAttachment eq $attachment );
 
-    $TWiki::Plugins::SESSION->{store}->moveAttachment(
+    $TWiki::STORE->moveAttachment(
         $web, $topic, $attachment,
         $newWeb, $newTopic, $newAttachment,
         $TWiki::Plugins::SESSION->{user} );
@@ -1834,7 +1817,7 @@
 sub readTemplate {
 #   my( $name, $skin ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{templates}->readTemplate( @_ );
+    return $TWiki::TEMPLATES->readTemplate( @_ );
 }
 
 =pod
@@ -1859,7 +1842,7 @@
 
 sub loadTemplate {
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{templates}->readTemplate( @_ );
+    return $TWiki::TEMPLATES->readTemplate( @_ );
 }
 
 =pod
@@ -1879,7 +1862,7 @@
 
 sub expandTemplate {
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{templates}->expandTemplate( @_ );
+    return $TWiki::TEMPLATES->expandTemplate( @_ );
 }
 
 =pod
@@ -2015,7 +1998,7 @@
 sub renderText {
 #   my( $text, $web ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{renderer}->getRenderedVersion( @_ );
+    return $TWiki::RENDER->getRenderedVersion( @_ );
 }
 
 =pod
@@ -2039,7 +2022,7 @@
     my $pre = shift;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
 #   my( $web, $topic, $label, $anchor, $anchor, $createLink ) = @_;
-    return $pre . $TWiki::Plugins::SESSION->{renderer}->internalLink( @_ );
+    return $pre . $TWiki::RENDER->internalLink( @_ );
 }
 
 =pod
@@ -2076,7 +2059,7 @@
 sub sendEmail {
     #my( $text, $retries ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{net}->sendEmail( @_ );
+    return $TWiki::NET->sendEmail( @_ );
 }
 
 =pod
@@ -2096,7 +2079,7 @@
     my( $wiki ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
     return '' unless $wiki;
-    my $user = $TWiki::Plugins::SESSION->{users}->findUser( $wiki, undef, 1 );
+    my $user = $TWiki::USERS->findUser( $wiki, undef, 1 );
     return '' unless $user;
     return join( ',', $user->emails() );
 }
@@ -2318,7 +2301,7 @@
 sub searchInWebContent {
     #my( $searchString, $web, $topics, $options ) = @_;
 
-    return $TWiki::Plugins::SESSION->{store}->searchInWebContent( @_ );
+    return $TWiki::STORE->searchInWebContent( @_ );
 }
 
 =pod
@@ -2347,7 +2330,7 @@
 sub getWorkArea {
     my( $plugin ) = @_;
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{store}->getWorkArea( $plugin );
+    return $TWiki::STORE->getWorkArea( $plugin );
 }
 
 =pod
@@ -2699,7 +2682,7 @@
 
 sub getPublicWebList {
     ASSERT($TWiki::Plugins::SESSION) if DEBUG;
-    return $TWiki::Plugins::SESSION->{store}->getListOfWebs("user,public");
+    return $TWiki::STORE->getListOfWebs("user,public");
 }
 
 =pod
Index: TWiki/Plugin.pm
===================================================================
--- TWiki/Plugin.pm	(revision 13172)
+++ TWiki/Plugin.pm	(working copy)
@@ -72,22 +72,19 @@
 
 =pod
 
----++ ClassMethod new( $session, $name, $module )
+---++ ClassMethod new( $name, $module )
 
-   * =$session= - TWiki object
    * =$name= - name of the plugin e.g. MyPlugin
    * =$module= - (options) name of the plugin class. Default is TWiki::Plugins::$name
 
 =cut
 
 sub new {
-    my ( $class, $session, $name, $module ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my ( $class, $name, $module ) = @_;
 
     my $this = bless( {}, $class );
     $name = TWiki::Sandbox::untaintUnchecked( $name );
     $this->{name} = $name || '';
-    $this->{session} = $session;
     $this->{module} = $module || 'TWiki::Plugins::'.$name;
 
     return $this;
@@ -124,17 +121,17 @@
     $this->{no_topic} = $noTopic;
 
     unless ($noTopic) {
-        my $store = $this->{session}->{store};
+        my $store = $TWiki::STORE;
         if ( $store->topicExists(
             $TWiki::cfg{SystemWebName}, $this->{name} ) ) {
             # found plugin in TWiki web
         } elsif ( $store->topicExists( 'Plugins', $this->{name} ) ) {
             # found plugin in Plugins web (compatibility, deprecated)
             $this->{installWeb} = 'Plugins';
-        } elsif ( $store->topicExists( $this->{session}->{webName},
+        } elsif ( $store->topicExists( $TWiki::SESSION->{webName},
                                        $this->{name} ) ) {
             # found plugin in current web
-            $this->{installWeb} = $this->{session}->{webName};
+            $this->{installWeb} = $TWiki::SESSION->{webName};
         } else {
             # not found
             push( @{$this->{errors}}, 'Plugins: could not fully register '.
@@ -148,7 +145,7 @@
     $this->{description} = eval '$'.$p.'::SHORTDESCRIPTION';
 
     # Set the session for this call stack
-    local $TWiki::Plugins::SESSION = $this->{session};
+    local $TWiki::Plugins::SESSION = $TWiki::SESSION;
 
     my $sub = $p . '::earlyInitPlugin';
     if( defined( &$sub ) ) {
@@ -166,9 +163,9 @@
     $sub = $p. '::initializeUserHandler';
     if( defined( &$sub ) ) {
         no strict 'refs';
-        $user = &$sub( $this->{session}->{remoteUser},
-                       $this->{session}->{cgiQuery}->url(),
-                       $this->{session}->{pathInfo} );
+        $user = &$sub( $TWiki::SESSION->{remoteUser},
+                       $TWiki::SESSION->{cgiQuery}->url(),
+                       $TWiki::SESSION->{pathInfo} );
         use strict 'refs';
     }
     #print STDERR "Compile $p: ".timestr(timediff(new Benchmark, $begin))."\n";
@@ -191,7 +188,7 @@
         return;
     }
 
-    my $prefs = $this->{session}->{prefs};
+    my $prefs = $TWiki::PREFS;
     if( !$this->{no_topic} ) {
         $prefs->pushPreferences( $this->{installWeb}, $this->{name}, 'PLUGIN',
                                  uc( $this->{name} ) . '_');
@@ -233,7 +230,7 @@
             $plugins->addListener( $h, $this );
         }
     }
-    $this->{session}->enterContext( $this->{name}.'Enabled' );
+    $TWiki::SESSION->enterContext( $this->{name}.'Enabled' );
 }
 
 # Invoke a handler
@@ -242,7 +239,7 @@
     my $handlerName = shift;
     my $handler = $this->{module}.'::'.$handlerName;
     no strict 'refs';
-    return &$handler( @_ );;
+    return &$handler( @_ );
     use strict 'refs';
 }
 
@@ -275,7 +272,7 @@
 
     unless( defined $this->{description} ) {
         my $pref = uc( $this->{name} ) . '_SHORTDESCRIPTION';
-        my $prefs = $this->{session}->{prefs};
+        my $prefs = $TWiki::PREFS;
         $this->{description} = $prefs->getPreferencesValue( $pref ) || '';
     }
     if( $this->{disabled} ) {
Index: TWiki/OopsException.pm
===================================================================
--- TWiki/OopsException.pm	(revision 13172)
+++ TWiki/OopsException.pm	(working copy)
@@ -66,23 +66,23 @@
 
 =pod
 
----++ ObjectMethod stringify( [$session] ) -> $string
+---++ ObjectMethod stringify() -> $string
 
-Generates a string representation for the object. if a session is passed in, and
+Generates a string representation for the object. if a session is available, and
 the excpetion specifies a def, then that def is expanded. This is to allow
 internal expansion of oops exceptions for example when performing bulk operations.
 
 =cut
 
 sub stringify {
-    my( $this, $session ) = @_;
+    my( $this ) = @_;
 
-    if ($this->{template} && $this->{def} && $session) {
+    if ($this->{template} && $this->{def} && $TWiki::SESSION) {
         # load the defs
-        $session->{templates}->readTemplate( 'oops'.$this->{template},
-                                             $session->getSkin() );
-        my $message = $session->{templates}->expandTemplate( $this->{def} );
-        $message = $session->handleCommonTags(
+        $TWiki::TEMPLATES->readTemplate( 'oops'.$this->{template},
+                                             $TWiki::SESSION->getSkin() );
+        my $message = $TWiki::TEMPLATES->expandTemplate( $this->{def} );
+        $message = $TWiki::SESSION->handleCommonTags(
             $message, $this->{web}, $this->{topic} );
         my $n = 1;
         foreach my $param ( @{$this->{params}} ) {
